hdu 4745 Two Rabbits(最长回文子序列DP)

37 篇文章 0 订阅

Description

Long long ago, there lived two rabbits Tom and Jerry in the forest. On a sunny afternoon, they planned to play a game with some stones. There were n stones on the ground and they were arranged as a clockwise ring. That is to say, the first stone was adjacent to the second stone and the n-th stone, and the second stone is adjacent to the first stone and the third stone, and so on. The weight of the i-th stone is ai. 

The rabbits jumped from one stone to another. Tom always jumped clockwise, and Jerry always jumped anticlockwise. 

At the beginning, the rabbits both choose a stone and stand on it. Then at each turn, Tom should choose a stone which have not been stepped by itself and then jumped to it, and Jerry should do the same thing as Tom, but the jumping direction is anti-clockwise. 

For some unknown reason, at any time , the weight of the two stones on which the two rabbits stood should be equal. Besides, any rabbit couldn't jump over a stone which have been stepped by itself. In other words, if the Tom had stood on the second stone, it cannot jump from the first stone to the third stone or from the n-the stone to the 4-th stone. 

Please note that during the whole process, it was OK for the two rabbits to stand on a same stone at the same time. 

Now they want to find out the maximum turns they can play if they follow the optimal strategy.

Input

The input contains at most 20 test cases. 
For each test cases, the first line contains a integer n denoting the number of stones. 
The next line contains n integers separated by space, and the i-th integer ai denotes the weight of the i-th stone.(1 <= n <= 1000, 1 <= ai <= 1000) 
The input ends with n = 0.

Output

For each test case, print a integer denoting the maximum turns.

Sample Input

1
1
4
1 1 2 1
6
2 1 1 2 1 3
0

Sample Output

1
4
5

        
  

Hint

For the second case, the path of the Tom is 1, 2, 3, 4, and the path of Jerry is 1, 4, 3, 2.
For the third case, the path of Tom is 1,2,3,4,5 and the path of Jerry is 4,3,2,1,5.

题意:

给定一个序列,两只兔子分别顺时针、逆时针走,每一个时刻它们到的石头上的数值要相同,最多只能走一圈,并且不能回到起点。求兔子最多可以跳的步数。

对于第二种情况,Tom的路径是1,2,3,4,Jerry的路径是1,4,3,2。
对于第三种情况,Tom的路径是1,2,3,4,5,Jerry的路径是4,3,2,1,5。

跳的距离不限制,两只兔子可以站到同一个石头上。

思路:

就是让求最长回文子序列的,第一个兔子和第二个兔子走过的路线是完全对称的,刚好构成回文子序列。

但是起点位置不确定。

看了别人的方法有两种解决的方法

一:

将链截成两段,分别求两部分的最长回文串长度,求和,枚举截点。由于链是环状的,枚举出的左边和右边两个回文串,一定可以从其中一个回文串的中心出发遍历两个回文串,比如1 2 2 1 3 4 4 3   ,一只兔子从第一个2出发向左走2 1 3 4 4 3 1 2 ,另一只向右出发走2 1 3 4 4 3 1 2  ,保证了两只兔子路径一样。

二:

将链倍增,求其长度为n的子串的最长回文子序列,例如上例,倍增之后串变成1 2 2 1 3 4 4 3 1 2 2 1 3 4 4 3,一定可以找到中间的2 1 3 4 4 3 1 2子序列形成最长回文序列,这种倍增相当于枚举了环上所有起始点的情况,任何一对i和i+n形成了和输入一样的环。

 

这里再讲解一下回文子序列的求法:

枚举子串的长度;

对每个长度为1的子串,回文长度肯定都是1;

对长度大于1的子串,假设其起点为i终点为j,如果s[i]==s[j],那么其回文串的长度肯定为2+dp[i+1][j-1],即将这两个点去掉之后的子串的最长回文长度加上边界上相等的两个点;如果s[i]!=s[j],这时候就当前串的最大回文长度肯定等于i~j-1和i+1~j两个子串的回文长度的较大者=max(dp[i+1][j],dp[i][j-1]);

至于为什么要枚举长度,因为长度短的是长度长的串的子串,在求长度长的串的时候,需要用到长度短的串的值,所以要枚举子串的长度形成递推。

代码如下:

#include<bits/stdc++.h>
using namespace std;
int a[1005];
int dp[1005][1005];
int main()
{
    int n;
    while (cin>>n&&n)
    {
        memset(dp,0,sizeof(dp));
        for(int i=1;i<=n;i++)
            cin>>a[i];
        for(int l=1;l<=n;l++)
        {
            for (int i=1;i+l-1<=n;i++)
            {
                int j=i+l-1;
                int k=2;
                if (i==j)
                    k=1;
                if (a[j]==a[i])
                    dp[i][j]=k+dp[i+1][j-1];
                else
                    dp[i][j]=max(dp[i][j-1],dp[i+1][j]);
            }
        }
        int ans=0;
        for (int i=0;i<=n;i++)
            ans=max(ans,dp[1][i]+dp[i+1][n]);
        cout<<ans<<endl;
    }
    return 0;
}

 

  • 4
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值